#include "reg52.h"

typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;
typedef signed int s16;
typedef signed long s32;

//ڶ
#define  FOSC  11059200UL
#define  BRT  (65536 - FOSC / 115200 / 4)

sfr  AUXR  =  0x8e;
sfr  T2H  =  0xd6;
sfr  T2L  =  0xd7;

bit  busy;

sfr WKTCL= 0xaa;
sfr WKTCH= 0xab;

sfr P3M1=0xb1;
sfr P3M0=0xb2;

u16 num[5];
u8 H,M,L,XL;
s32 T;


//BMP280
sbit SCL=P3^6;
sbit SDA=P3^7;

u8 addr_W=0xec;    //SDOӵ
u8 addr_R=0xed;	   //SDOӵ

u16 dig_T1;
s16 dig_T2,dig_T3;
u16 dig_P1;
s16 dig_P2,dig_P3,dig_P4,dig_P5,dig_P6,dig_P7,dig_P8,dig_P9;
           //¶ֵ

void delay(u16 i)
{
	while(i--);
}

void I2C_Start()
{
	SCL=1;
	SDA=1;
	delay(1);
	SDA=0;
	delay(1);
	SCL=0;
	delay(1);
}

void I2C_Stop()
{
	SDA=0;
	SCL=0;
	delay(1);
	SCL=1;
	delay(1);
	SDA=1;
	delay(1);
}

u8 I2C_Wait_ACK()
{
	u8 Err;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1);
	while(SDA)
	{
		Err++;
		if(Err>200)
		{
			I2C_Stop();
			return 0;
		}
	}
	SCL=0;
	delay(1);
	return 1;
}

void I2C_ACK()
{
	 SCL=0;
	 SDA=0;
	 delay(1);
	 SCL=1;
	 delay(1);
	 SCL=0;
	 delay(1);
}

void I2C_NACK()
{
	SCL=0;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1);
    SCL=0;
	delay(1);
}

void I2C_Send_Byte(u8 tx)
{
	u8 i;
	SCL=0;
	for(i=0;i<=7;i++)
	{
		 SDA=(tx&0x80)>>7;
		 tx<<=1;

		 delay(1);
		 SCL=1;
		 delay(1);
		 SCL=0;
		 delay(1);
	}
}

u8 I2C_Read_Byte(u8 ack)
{
	u8 a;
	u8 rec;
	for(a=0;a<=7;a++)
	{
		 SCL=0;
		 delay(1);
		 SCL=1;

		 rec<<=1;
		 rec|=SDA;
		 delay(1);
	}
	if(ack==1)
	   I2C_ACK();
	else 
	   I2C_NACK();
	return rec;
}

void BMP280_Write_Byte(u8 addr,u8 dat)
{
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(addr);
	I2C_Wait_ACK();
	I2C_Send_Byte(dat);
	I2C_Wait_ACK();
	I2C_Stop();
}

u8 BMP280_Read_Byte(u8 addr)
{
	u8 tmp;
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(addr);
	I2C_Wait_ACK();
    
	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();
	tmp=I2C_Read_Byte(0);
	//I2C_NACK();
	I2C_Stop();

	return tmp;
}

s16 BMP280_Read_Two(u8 addr)
{	
	 u8 lsb,msb;
	 s16 tmp;

	 lsb=BMP280_Read_Byte(addr);
	 msb=BMP280_Read_Byte(addr+1);

	 tmp=(s16)msb<<8;
	 tmp|=(s16)lsb;

	 return tmp;
}

s32 BMP280_Read_Three(u8 addr)
{
	u8 msb,lsb,xlsb;
	s32 tmp;

	msb=BMP280_Read_Byte(addr);
	lsb=BMP280_Read_Byte(addr+1);
	xlsb=BMP280_Read_Byte(addr+2);

	tmp=(s32)(((u32)msb<<16)|((u32)lsb<<8)|((u32)xlsb));
	tmp/=16;				//4λݣ4λ
	return tmp;
}

void BMP280_Init()
{
  u8 id;
	
	BMP280_Write_Byte(0xe0,0xb6);    //λ
  delay(500);

	id=BMP280_Read_Byte(0xd0);		 //ȡid
	if(id==0x58)					 //ʼʼ
	{
		 BMP280_Write_Byte(0xf4,0xff);		   //20λ¶Ȳ20λѹģʽ
		 BMP280_Write_Byte(0xf5,0x00);		   //0.5ms

		 //ϣʼȡУ׼ֵ
		 
		 dig_T1=(u16)BMP280_Read_Two(0x88);
		 dig_T2=(s16)BMP280_Read_Two(0x8a);
		 dig_T3=(s16)BMP280_Read_Two(0x8c);
		 dig_P1=(u16)BMP280_Read_Two(0x8e);
		 dig_P2=(s16)BMP280_Read_Two(0x90);
		 dig_P3=(s16)BMP280_Read_Two(0x92);
		 dig_P4=(s16)BMP280_Read_Two(0x94);
		 dig_P5=(s16)BMP280_Read_Two(0x96);
		 dig_P6=(s16)BMP280_Read_Two(0x98);
		 dig_P7=(s16)BMP280_Read_Two(0x9a);
		 dig_P8=(s16)BMP280_Read_Two(0x9c);
		 dig_P9=(s16)BMP280_Read_Two(0x9e);
		  
		 delay(5000);
	} 
	/*
	dig_T1=27504;
	dig_T2=26435;
	dig_T3=-1000;
    dig_P1=36477;
	dig_P2=-10685;
	dig_P3=3024;
	dig_P4=2855;
	dig_P5=140;
	dig_P6=-7;
	dig_P7=15500;
	dig_P8=-14600;
	dig_P9=6000;
	*/
	     
}

s32 BMP280_Get()
{
	s32 adc_T,adc_P;
	s32 var1,var2,t_fine,P;

	adc_T=BMP280_Read_Three(0xfa);					 //¶ֵ
	adc_P=BMP280_Read_Three(0xf7);					 //ѹֵ

	//adc_T=519888;
	//adc_P=415148;

	//¶ֵ
    var1=(((double)adc_T)/16384.0-((double)dig_T1)/1024.0)*((double)dig_T2);
	var2=((((double)adc_T)/131072.0-((double)dig_T1)/8192.0)*(((double)adc_T)/131072.0-((double)dig_T1)/8192.0))*((double)dig_T3);
	t_fine=(u32)(var1+var2);
	T=(s32)(var1+var2)/5210.0;

	//ѹ
	var1 = ((double)t_fine/2.0)-64000.0;
    var2 = var1*var1*((double)dig_P6)/32768.0;
    var2 = var2 +var1*((double)dig_P5)*2.0;
    var2 = (var2/4.0)+(((double)dig_P4)*65536.0);
    var1 = (((double)dig_P3)*var1*var1/524288.0+((double)dig_P2)*var1)/524288.0;
    var1 = (1.0+var1/32768.0)*((double)dig_P1);
    P = 1048576.0-(double)adc_P;
    P = (P-(var2/4096.0))*6250.0/var1;
    var1 = ((double)dig_P9)*P*P/2147483648.0;
    var2 = P*((double)dig_P8)/32768.0;
    P=P+(var1+var2+((double)dig_P7))/16.0;

	return P;

}
							   
/***********************                   *************************/
void UartIsr() interrupt 4 using 1
{
  if (TI)
  {
    TI = 0;
    busy = 0;
  }
}

void UartInit()
{
	SCON = 0x50;
	T2L = BRT;
	T2H = BRT >> 8;
	AUXR = 0x15;

	busy = 0;
}

void UartSend(u8 dat)
{
	while (busy);
	busy = 1;
	SBUF = dat;	
}

void UartSendStr(char *p)
{
	while (*p)
	{
		UartSend(*p++);
	}
}

void SendLong(s32 dat)						 //ַ
{
	u16 count[20];
	u8 i;
	while(dat)
	{
		count[i]=dat%10;
		dat=dat/10;
		i++;
	}
	while(i>0)
	{
		SBUF=count[i-1]+'0';
		while(!TI);
		TI=0;
		i--;
	}
	
}

void main()
{
	s32 tmp;
	
	P3M1=0;
	P3M0=0;

	SCL=1;
	SDA=1;
     
	BMP280_Init();
	UartInit();
	ES = 1;
	EA = 1;

	WKTCL=0x0b;
	WKTCH=0x50|0x80;//?10?????
	
	PCON|=0x02;//??????,CPU????,????????

	while(1)
	{
		BMP280_Write_Byte(0xf4,0xff);	//bmp280
	 	tmp=BMP280_Get();
		//process(tmp);

		UartSendStr("Press: ");
		SendLong(tmp);		 //ѹ

		SBUF=' ';		     //ո
		while(!TI);
		TI=0;

		UartSendStr("Tem: ");
		SendLong(T);		 //¶

		SBUF='\n';		     //з
		while(!TI);
		TI=0;

		BMP280_Write_Byte(0xf4,0xfc);	//رbmp280
		PCON|=0x02;
		//delay(50000);
	}

}