#include "reg52.h"
#include "main.h"

sbit SDA=P1^7;
sbit SCL=P1^6;

typedef unsigned char u8;
typedef unsigned int u16;

u8 addr_W=0x46;
u8 addr_R=0x47;      //addrŵ͵ƽ
u8 ConMea=0x20;      //θ߾Ȳָ

#define  FOSC  11059200UL
#define  BRT  (65536 - FOSC / 115200 / 4)

sfr  AUXR  =  0x8e;
sfr  T2H  =  0xd6;
sfr  T2L  =  0xd7;

sfr WKTCL=0xaa;
sfr WKTCH=0xab;

u16 lux;


void delay(u16 i)
{
	while(i--);
	
}

void I2C_Start()
{
	SCL=1;
	SDA=1;
	delay(1);
	SDA=0;
	delay(1);
	SCL=0;
	delay(1);
}

void I2C_Stop()
{
	SDA=0;
	SCL=0;
	delay(1);
	SCL=1;
	delay(1);
	SDA=1;
	delay(1);
}

u8 I2C_Wait_ACK()
{
	u8 Err;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1);
	while(SDA)
	{
		Err++;
		if(Err>200)
		{
			I2C_Stop();
			return 0;
		}
	}
	SCL=0;
	delay(1);
	return 1;
}

void I2C_ACK()
{
	 SCL=0;
	 SDA=0;
	 delay(1);
	 SCL=1;
	 delay(1);
	 SCL=0;
	 delay(1);
}

void I2C_NACK()
{
	SCL=0;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1);
  SCL=0;
	delay(1);
}

void I2C_Send_Byte(u8 tx)
{
	u8 i;
	SCL=0;
	for(i=0;i<=7;i++)
	{
		 SDA=(tx&0x80)>>7;
		 tx<<=1;

		 delay(1);
		 SCL=1;
		 delay(1);
		 SCL=0;
	}
}

u8 I2C_Read_Byte(u8 ack)
{
	u8 a;
	u8 rec;
	SDA=1;
	for(a=0;a<=7;a++)
	{
		 SCL=0;
		 delay(1);
		 SCL=1;

		 rec<<=1;
		 rec|=SDA;
		
		 delay(1);
	}
	if(ack==1)
	   I2C_ACK();
	else 
	   I2C_NACK();
	return rec;
}

u16 bh1750_Read()
{
	u8 H,L,j;
	u16 Lx;
	
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(0x01);   //power on
	I2C_Wait_ACK();
	I2C_Stop();
	
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(ConMea);   //
	I2C_Wait_ACK();
	I2C_Stop();

	for(j=0;j<=133;j++)
	   delay(1000);   //120ms
		 
	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();
	H=I2C_Read_Byte(1);   //ack
	L=I2C_Read_Byte(0);   //Nack
	I2C_Stop();
	Lx=(u16)((H<<8)|L);
	return Lx;
}

void UartInit()
{
	SCON = 0x50;
	T2L = BRT;
	T2H = BRT >> 8;
	AUXR = 0x15;
}


void SendInt(u16 dat)						 //??????
{
	u16 count[20];
	u8 i=0;
	while(dat)
	{
		count[i]=dat%10;
		dat=dat/10;
		i++;
	}
	while(i>0)
	{
		SBUF=count[i-1]+'0';
		while(!TI);
		TI=0;
		i--;
	}
	
}

void main()
{
	P0M1=0;
	P0M0=0;
	P1M1=0;
	P1M0=0;
	P2M1=0;
	P2M0=0;
	P3M1=0;
	P3M0=0;
	P4M1=0;
	P4M0=0;
	P5M1=0;
	P5M0=0;

	UartInit();
	ES = 1;
	EA = 1;
	
	while(1)
	{
		lux=bh1750_Read();
    lux=(u16)lux/1.2;
		SendInt(lux);

		SBUF='\n';		     //???
		while(!TI);
		TI=0;

		delay(60000);
	}
}
