#include "reg52.h"

sbit SDA=P3^7;
sbit SCL=P3^6;


typedef unsigned int u16;	  //ͽ
typedef unsigned char u8;
typedef unsigned long u32;


u8 addr_W=0x80;			 //дָ
u8 addr_R=0x81;			 //ָ
u8 RST_Code=0xfe;		 //λ
u8 Wuser_Code=0xe6;		 //дûĴ
u8 Ruser_Code=0xe7;		 //ûĴ
u8 RH_Code=0xf5;	     //Ǳģʽʪ
u8 T_Code=0xf3;			 //Ǳģʽ¶

#define  FOSC  11059200UL
#define  BRT  (65536 - FOSC / 115200 / 4)

sfr  AUXR  =  0x8e;
sfr  T2H  =  0xd6;
sfr  T2L  =  0xd7;

bit  busy;

u16 num[5];
u8 H,M,L,XL;
u16 value;


sfr WKTCL= 0xaa;
sfr WKTCH= 0xab;

void delay(u16 i)		      //i=1, delay 1us
{
	while(i--);	
}
/******************************************    ***************************************************/
void UartIsr() interrupt 4 using 1
{
  if (TI)
  {
    TI = 0;
    busy = 0;
  }
}

void UartInit()
{
	SCON = 0x50;
	T2L = BRT;
	T2H = BRT >> 8;
	AUXR = 0x15;

	busy = 0;
}

void UartSend(u8 dat)
{
	while (busy);
	busy = 1;
	SBUF = dat;	
}

void UartSendStr(char *p)
{
	while (*p)
	{
		UartSend(*p++);
	}
}

void process(u32 dat)						  //ݴָ
{
	
	H=(unsigned char)(dat>>24);
	M=(unsigned char)((dat>>16)&(0x00ff));
	L=(unsigned char)((dat>>8)&(0x0000ff));
	XL=(unsigned char)(dat&0x000000ff);

	num[0]=H;
	num[1]=M;

	num[2]=L;
	num[2]*=256;

	num[3]=XL;
	num[4]='\n';

	value=num[2]+num[3];
}

void SendInt(u16 dat)						 //ַ
{
	u16 count[20];
	u8 i;
	while(dat)
	{
		count[i]=dat%10;
		dat=dat/10;
		i++;
	}
	while(i>0)
	{
		SBUF=count[i-1]+'0';
		while(!TI);
		TI=0;
		i--;
	}
	
}
/********************************   I2Cͨ   *****************************************************************/



void I2C_Init()
{
 	SDA=1;
	SCL=1;
}
void I2C_Start()
{
    SDA=1;
	SCL=1;
	delay(1);
	SDA=0;
	delay(1);
	SCL=0;
	delay(1);
}

void I2C_Stop()
{
    SDA=0;
	SCL=0;
	delay(1);
	SCL=1;
	delay(1);//ʱ4.7us
	SDA=1;
	delay(1);		
}

u8 I2C_Wait_ACK()
{
    u8 Err;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1) ;
	while(SDA)
	{
		Err++;
		if(Err>200)
		{
		    I2C_Stop();
			return 0;
		}
	}
	SCL=0;
	delay(1);
	return 1;
}

void I2C_ACK()
{
	SCL=0;
	SDA=0;
	delay(1);
	SCL=1;
	delay(1);
	SCL=0;
	delay(1);
}

void I2C_NACK()
{
	SCL=0;
	SDA=1;
	delay(1);
	SCL=1;
	delay(1);
	SCL=0;
	delay(1);
}

void I2C_Send_Byte(u8 tx)			//MSB
{
	u8 i;

	SCL=0;
	for(i=0;i<=7;i++)
	{
		SDA=(tx&0x80)>>7;
		tx<<=1;

		delay(1);
		SCL=1;
		delay(1);
		SCL=0;
		delay(1);
	}
}

u8 I2C_Read_Byte(u8 ack)
{
     u8 a;
	 u8 rec;

	 for(a=0;a<=7;a++)
	 {
	 	SCL=0;
		delay(1);
		SCL=1;
		rec<<=1;
		rec|=SDA;
		delay(1);
	 }

	 if(ack==1)
	    I2C_ACK();
	 else
	    I2C_NACK();

	 return rec;
}

void SHT20_Re()						   //ֱ 
{
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(Wuser_Code);
	I2C_Wait_ACK();
	I2C_Send_Byte(0x3b);	     //8 bit ʪ 12 bit¶
	I2C_Wait_ACK();

	I2C_Stop();
}

void STH20_Init()
{
	I2C_Init();
	I2C_Start();
	I2C_Send_Byte(addr_W);
	
	I2C_Wait_ACK();
	I2C_Send_Byte(RST_Code);     //λ
	I2C_Wait_ACK();
	I2C_Stop();
	delay(5000);       
	
	SDA=1;
	SCL=1;

	SHT20_Re();
}


u8 SHT20_Read()						  //ȡ
{
  u8 reg;

	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(Ruser_Code);
	I2C_Wait_ACK();

	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();

	reg=I2C_Read_Byte(0);

	I2C_Stop();

	return reg;
}

u8 SHT20_Bat()					 //͵ѹ
{
	u8 bat;

	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(Ruser_Code);
	I2C_Wait_ACK();

	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();

	bat=I2C_Read_Byte(0);

	I2C_Stop();

	bat=(bat&0x40)>>6;

	return bat;
}

u16 SHT20_ReadRH()
{
    u16 rh;
	u32 RH;

	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(RH_Code);
	I2C_Wait_ACK();

	delay(5000);				//ģʽ ȴ5ms
	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();

	rh=I2C_Read_Byte(1);
	rh*=256;					//8λ
	rh=rh|I2C_Read_Byte(0);    // msb  lsb

    I2C_Stop();

	rh=rh&0xfffc;
	RH=(u32)rh*12500;				  //λС
	RH/=65536;
    RH-=600;

	return RH;
}

u16 SHT20_ReadT()
{
    u16 t;
	u32 T;
	I2C_Start();
	I2C_Send_Byte(addr_W);
	I2C_Wait_ACK();
	I2C_Send_Byte(T_Code);
	I2C_Wait_ACK();

	delay(25000);                  //ģʽȴ25ms
	I2C_Start();
	I2C_Send_Byte(addr_R);
	I2C_Wait_ACK();

	t=I2C_Read_Byte(1);
	t*=256;
    t=t|I2C_Read_Byte(0);

	I2C_Stop();

	t=t&0xfffc;
	T=(u32)t*17572;
	T/=65536;
	T-=4685;

	return T;
}

void main()
{
    u32 Dat_RH,Dat_T;

    delay(1500);     //״̬

    STH20_Init();

	UartInit();
	ES = 1;
	EA = 1;

	WKTCL=0x0b;
	WKTCH=0x50|0x80;//?10?????
	
	PCON|=0x02;//??????,CPU????,????????
	while(1)
	{
		
	if(!SHT20_Bat())
	{
		Dat_RH=SHT20_ReadRH();
		Dat_T=SHT20_ReadT();
        
		UartSendStr("\nRH:\r");
		process(Dat_RH);
		SendInt(value);

		SBUF=' ';		     //ո
		while(!TI);
		TI=0;

		UartSendStr("\nT:\r");
		process(Dat_T);
		SendInt(value);

		SBUF='\n';		     //з
		while(!TI);
		TI=0;

		//delay(50000);	
	}
	PCON|=0x02;
	delay(1); 
	}
}

